<template>
  <fieldset>

    <fieldset>
      <RadioToggleBorderedLabel
          :active="currentSettings.remoteFiles"
          field-id="remoteFiles"
          :text="t('remote_files_toggle_label')"
      >
      </RadioToggleBorderedLabel>
      <input
          type="hidden"
          name="pdfFileId"
          id="pdfFileId"
          ref="pdfFileIdInput"
          :value="currentSettings.pdfFileId"
      />
    </fieldset>
    <fieldset v-if="currentSettings.remoteFiles">

        <TextInputFloatingLabel
            for="remotePdfFileUrl"
            :text="t('remote_url_label')"
        >
          <input
              type="url"
              id="remotePdfFileUrl"
              name="remotePdfFileUrl"
              pattern="http[s]{0,1}://.*"
              placeholder="https://domain.tld/file.pdf"
              required
              :value="currentSettings.remotePdfFileUrl"
              class="input-group-field"
          />
        </TextInputFloatingLabel>
    </fieldset>
    <fieldset v-else>
      <p v-if="pdfFile">
        {{ t('current_file_label') }}: {{ pdfFile.filename }}
        <button
            type="button"
            class="button alert"
            @click="deleteFile(pdfFile.id)"
        >
          X
        </button>
      </p>
      <fieldset v-else @change.prevent="cancel">
        <div class="upload-controls">
          <button
              v-if="selectedFile"
              type="button"
              class="button hollow alert"
              @click="clearFileInput"
          >
            x
          </button>
          <label for="pdfFile" class="button hollow">{{
              selectedFile.length > 0 ? selectedFile : t("file_input_label")
            }}</label>
          <input
              type="file"
              id="pdfFile"
              class="show-for-sr"
              name="upload[file]"
              required
              accept="application/pdf"
              @change.prevent="setInputState"
          />
          <input
              type="submit"
              class="button"
              @click.prevent="uploadPdf"
              :disabled="selectedFile.length === 0 || uploading"
              :value="uploadButtonLabel"
          />
        </div>
      </fieldset>
      <p v-if="error" class="pictures__error">{{ error }}</p>
    </fieldset>

  </fieldset>
</template>

<script>
module.exports = {
  name: "mirros-widget-embed-pdf",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true,
    },
  },
  data: function () {
    return {
      pdfFile: null,
      selectedFile: "",
      uploading: false,
      error: ""
    }
  },
  computed: {
    uploadButtonLabel() {
      return this.uploading
          ? this.$translate.text("upload_button_uploading_state")
          : this.$translate.text("upload_button_label");
    },
  },
  beforeMount() {
    this.fetchPDFFile();
  },
  methods: {
    cancel: function (e) {
      e.stopPropagation();
    },
    setInputState: function (e) {
      this.selectedFile =
          e.target.files[0] !== undefined ? e.target.files[0].name : "";
    },
    clearFileInput: function () {
      const fileInput = document.getElementById("pictureImageFile");
      fileInput.value = "";
      fileInput.dispatchEvent(new Event("change"));
    },
    uploadPdf: async function (e) {
      let fd = new FormData(e.target.form);
      try {
        this.uploading = true;
        const response = await fetch(
            `${this.backendUrl}/embed_pdf/pdf_uploads`,
            {
              method: "POST",
              body: fd,
            }
        )
        const data = await response.json();
        if (!response.ok) {
          this.error = data;
          return;
        }
        this.pdfFile = data;

        this.$refs.pdfFileIdInput.value = data.id;
        this.$refs.pdfFileIdInput.dispatchEvent(new Event("change", {bubbles: true}));


      } catch (error) {
        this.error = error;
      } finally {
        e.target.form.reset();
        this.selectedFile = "";
        this.uploading = false;
      }
    },
    deleteFile: async function (id) {
      await fetch(`${this.backendUrl}embed_pdf/pdf_uploads/${id}`, {
        method: "DELETE",
      });
      this.pdfFile = null;
      this.$refs.pdfFileIdInput.value = "";
      this.$refs.pdfFileIdInput.dispatchEvent(new Event("change", {bubbles: true}));
    },
    fetchPDFFile: async function () {
      const response = await fetch(
          `${this.backendUrl}embed_pdf/pdf_uploads`
      ).then((res) => res.json());
      this.pdfFile = response[0];
    },

  },
  locales: {
    enGb: {
      remote_files_toggle_label: "Embed PDF from URL",
      current_file_label: "Currently displayed file",
      file_input_label: "Choose PDF file",
      upload_button_label: "Upload PDF",
      upload_button_uploading_state: "Uploading …",
      remote_url_label: "PDF file URL",
    },
    deDe: {
      remote_files_toggle_label: "PDF von URL einbetten",
      current_file_label: "Aktuell angezeigte Datei",
      file_input_label: "PDF-Datei auswählen",
      upload_button_label: "PDF hochladen",
      upload_button_uploading_state: "Hochladen …",
      remote_url_label: "PDF-Datei URL",
    },
    frFr: {
      remote_files_toggle_label: "Intégrer un PDF à partir d'une URL",
      current_file_label: "Fichier actuellement affiché",
      file_input_label: "Choisir le fichier PDF",
      upload_button_label: "Télécharger le PDF",
      upload_button_uploading_state: "Télécharger …",
      remote_url_label: "URL du fichier PDF",
    },
    esEs: {
      remote_files_toggle_label: "Incrustar PDF desde URL",
      current_file_label: "Archivo mostrado actualmente",
      file_input_label: "Elegir archivo PDF",
      upload_button_label: "Cargar PDF",
      upload_button_uploading_state: "Cargar …",
      remote_url_label: "URL del archivo PDF",
    },
    plPl: {
      remote_files_toggle_label: "Osadzenie PDF z adresu URL",
      current_file_label: "Aktualnie wyświetlany plik",
      file_input_label: "Wybierz plik PDF",
      upload_button_label: "Prześlij PDF",
      upload_button_uploading_state: "Uploading …",
      remote_url_label: "URL pliku PDF",
    },
    koKr: {
      remote_files_toggle_label: "URL에서 PDF 포함",
      current_file_label: "현재 표시된 파일",
      file_input_label: "PDF 파일 선택",
      upload_button_label: "PDF 업로드",
      upload_button_uploading_state: "업로드 중...",
      remote_url_label: "PDF 파일 URL",
    }
  }
}
</script>

<style scoped>
.upload-controls {
  display: flex;
  justify-content: space-between;
}

.pictures__error {
  color: red;
}
</style>
